## libnop 0.0~git20211103.35e800d

=== Makefile ===
what_to_build:: all

-include local.mk

TOOLCHAIN ?=

HOST_OS := $(shell uname -s)

WITH_COVERAGE ?= false

# Location of gtest in case it's not installed in a default path for the compiler.
GTEST_INSTALL ?= /opt/local
GTEST_LIB ?= $(GTEST_INSTALL)/lib
GTEST_INCLUDE ?= $(GTEST_INSTALL)/include

HOST_CFLAGS := -g -O2 -Wall -Werror -Wextra -Iinclude
HOST_CXXFLAGS := -std=c++14
HOST_LDFLAGS :=

ifeq ($(HOST_OS),Linux)
HOST_LDFLAGS := -lpthread
endif

OUT := out
OUT_HOST_OBJ := $(OUT)/host-obj

ALL :=
DEPS :=

# Determine whether the compiler can find gtest.
HAS_GTEST := $(shell \
	echo "\#include <gtest/gtest.h>" \
	| $(CXX) -I$(GTEST_INCLUDE) -x c++ -E - > /dev/null 2>&1 \
	&& echo yes)

# Print warning if gtest is not found.
ifneq ("$(HAS_GTEST)","yes")

$(warning libgtest not found in default compiler paths.)
$(warning To build tests either install libgtest in a default location)
$(warning or specify with the environment variable GTEST_INSTALL.)

else

# Build tests if gtest is found.
M_NAME := test
M_CFLAGS := -I$(GTEST_INCLUDE) -O0 -g
M_LDFLAGS := -L$(GTEST_LIB) -lgtest -lgmock
M_OBJS := \
	test/nop_tests.o \
	test/encoding_tests.o \
	test/serializer_tests.o \
	test/utility_tests.o \
	test/variant_tests.o \
	test/handle_tests.o \
	test/thread_local_tests.o \
	test/enum_flags_tests.o \
	test/sip_hash_tests.o \
	test/interface_tests.o \
	test/fungible_tests.o \
	test/optional_tests.o \
	test/result_tests.o \
	test/endian_tests.o \
	test/constexpr_tests.o \

ifeq ($(WITH_COVERAGE),true)
M_CFLAGS += --coverage
endif

include build/host-executable.mk

ifeq ($(WITH_COVERAGE),true)
# Generate coverage report with lcov and genhtml. A bit hacky but works okay.
$(OUT)/coverage.info: $(OUT)/test
	$(QUIET)find $(OUT) -name "*.gcda" -exec rm {} \+
	$(QUIET)$(OUT)/test
	lcov --capture --directory $(OUT_HOST_OBJ)/test/test/ --output-file $@ --no-external --base-directory .
	mkdir -p $(OUT)/coverage
	genhtml -o $(OUT)/coverage $@

coverage:: $(OUT)/coverage.info
endif

endif

# Build examples.

M_NAME := stream_example
M_OBJS := \
	examples/stream.o

include build/host-executable.mk

M_NAME := simple_protocol_example
M_OBJS := \
	examples/simple_protocol.o

include build/host-executable.mk

M_NAME := interface_example
M_OBJS := \
	examples/interface.o

include build/host-executable.mk

M_NAME := pipe_example
M_OBJS := \
	examples/pipe.o

include build/host-executable.mk

M_NAME := table_example
M_OBJS := \
	examples/table.o

include build/host-executable.mk

M_NAME := variant_example
M_OBJS := \
	examples/variant.o

include build/host-executable.mk

M_NAME := shared_protocol.so
M_CFLAGS := -fPIC
M_LDFLAGS := --shared
M_OBJS := \
	examples/shared.o

include build/host-executable.mk

clean::
	@echo clean
	@rm -rf $(OUT)

all:: $(ALL)

# we generate .d as a side-effect of compiling. override generic rule:
%.d:
-include $(DEPS)

## libnop 0.0~git20200728.45dfe0f

=== debian/changelog ===
libnop (0.0~git20200728.45dfe0f-5) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Apply multi-arch hints. + libnop-dev: Add Multi-Arch: same.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Adrian Bunk ]
  * d/patches/tests-opt.patch: Build tests with default optimization
    (Closes: #1079562)

 -- Aron Xu <aron@debian.org>  Tue, 03 Sep 2024 21:51:51 +0800

libnop (0.0~git20200728.45dfe0f-4) unstable; urgency=medium

  * Cherry-pick upstream commit to fix GCC-11 FTBFS. (Closes: #984190)
  * Add d/watch file to track upstream changes.

 -- Mo Zhou <lumin@debian.org>  Sat, 13 Nov 2021 15:08:42 -0500

libnop (0.0~git20200728.45dfe0f-3) unstable; urgency=medium

  * Cherry-pick upstream patch to fix FTBFS on 32-bit archs. (Closes: #973799)

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Dec 2020 14:15:01 +0800

libnop (0.0~git20200728.45dfe0f-2) unstable; urgency=medium

  * Upload to unstable.
  * Please pin to this upstream snapshot for the snapshot of tensorpipe
    required by PyTorch 1.7.0 as build dependency.

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 11:06:52 +0800

libnop (0.0~git20200728.45dfe0f-1) experimental; urgency=medium

  * Initial release. (Closes: #973341)

 -- Mo Zhou <lumin@debian.org>  Sat, 31 Oct 2020 11:20:12 +0800

=== debian/control ===
Source: libnop
Section: libdevel
Homepage: https://github.com/google/libnop
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/deeplearning-team/libnop.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/libnop
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13), libgtest-dev, libgmock-dev,
Rules-Requires-Root: no

Package: libnop-dev
Architecture: any
Depends: ${misc:Depends}
Multi-Arch: same
Description: C++ Native Object Protocols
 libnop is a header-only library for serializing and deserializing C++ data
 types without external code generators or runtime support libraries. The only
 mandatory requirement is a compiler that supports the C++14 standard.
 .
 libnop has the following goals:
 .
   * Make simple serialization tasks easy and complex tasks tractable.
   * Remove the need to use code generators and schema files to describe
     data types, formats, and protocols: perform these tasks naturally
     within the C++ language.
   * Avoid additional runtime support requirements for serialization.
   * Provide contemporary features such as bidirectional binary
     compatibility, data validation, type safety, and type fungibility.
   * Handle intrinsic types, common STL types and containers, and
     user-defined types with a minimum of effort.
   * Produce optimized code that is easy to analyze and profile.
   * Avoid internal dynamic memory allocation when possible.

## libnop 0.0~git20211103.35e800d

=== debian/changelog ===
libnop (0.0~git20211103.35e800d-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20211103.35e800d.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * d/patches: remove applied patches.
  * d/patches: remove hardcoded -std=c++14 to fix FTBFS to make gtest happy.
    (closes: #1114177)
  * d/control: mark libnop-dev as Architecture: all since it's header-only.

 -- Shengqi Chen <harry@debian.org>  Sat, 13 Sep 2025 17:32:10 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libdevel
 Homepage: https://github.com/google/libnop
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/libnop.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/libnop
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -11,9 +11,9 @@
 Rules-Requires-Root: no
 
 Package: libnop-dev
-Architecture: any
+Architecture: all
 Depends: ${misc:Depends}
-Multi-Arch: same
+Multi-Arch: foreign
 Description: C++ Native Object Protocols
  libnop is a header-only library for serializing and deserializing C++ data
  types without external code generators or runtime support libraries. The only

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_after_dh_auto_test:
	find out -type f -executable ! -name '*.so' -exec '{}' \;

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/google/libnop \
HEAD debian uupdate
